include dll.e
include machine.e
include wildcard.e

-- changes app_fill_rect -> app_window_fill_app(en niet euapp_fill_rect)
-- changes get_window_area , parameter 3,4 i.p.v. 1,2
-- get_image_area declaired twice .
-- put a event_scanner into it by callbackId=next_event()(idea from JAPI)
-- convert all hook's the same way -1=none 0=event_scanner else callbackfunc()
--without warning

global constant EUAPP_VERSION = "euApp 1.0"

sequence cmdline
atom ga,cmdptr,app
cmdline=command_line()
ga=open_dll("libapp.so")
if ga=0 then ga=open_dll("./libapp.so") end if
if ga=0 then ga=open_dll("graphapp.dll") end if
if ga=0 then puts(1,"unable to load GraphApp\n") abort(1) end if

global type Point(sequence s) return length(s)=2 end type
global type Rect(sequence s) return length(s)=4 end type

constant app_new_app=define_c_func(ga,"app_new_app",{C_INT,C_POINTER},C_POINTER),
app_del_app=define_c_proc(ga,"app_del_app",{C_POINTER}),
app_new_window=define_c_func(ga,"app_new_window",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT},C_POINTER),
app_show_window=define_c_proc(ga,"app_show_window",{C_POINTER}),
app_hide_window=define_c_proc(ga,"app_hide_window",{C_POINTER}),
app_del_window=define_c_proc(ga,"app_del_window",{C_POINTER}),
app_del_all_windows=define_c_proc(ga,"app_del_all_windows",{C_POINTER}),
app_hide_all_windows=define_c_proc(ga,"app_hide_all_windows",{C_POINTER}),
app_main_loop=define_c_proc(ga,"app_main_loop",{C_POINTER}),
app_wait_event=define_c_func(ga,"app_wait_event",{C_POINTER},C_POINTER),

app_new_button=define_c_func(ga,"app_new_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_image_button=define_c_func(ga,"app_new_image_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_list_box=define_c_func(ga,"app_new_list_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_image_check_box=define_c_func(ga,"app_new_image_check_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_check_box=define_c_func(ga,"app_new_check_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_radio_button=define_c_func(ga,"app_new_radio_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_radio_group=define_c_func(ga,"app_new_radio_group",{C_POINTER},C_POINTER),
app_new_field=define_c_func(ga,"app_new_field",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_new_password_field=define_c_func(ga,"app_new_password_field",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_new_text_box=define_c_func(ga,"app_new_text_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_new_image_label=define_c_func(ga,"app_new_image_label",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT},C_POINTER),
app_new_label=define_c_func(ga,"app_new_label",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT},C_POINTER),
app_new_tab_button=define_c_func(ga,"app_new_tab_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_control=define_c_func(ga,"app_new_control",{C_POINTER,C_INT,C_INT,C_INT,C_INT},C_POINTER),
app_new_drop_list=define_c_func(ga,"app_new_drop_list",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_new_drop_field=define_c_func(ga,"app_new_drop_field",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_new_scroll_bar=define_c_func(ga,"app_new_scroll_bar",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),

app_add_button=define_c_func(ga,"app_add_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_image_button=define_c_func(ga,"app_add_image_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_list_box=define_c_func(ga,"app_add_list_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_image_check_box=define_c_func(ga,"app_add_image_check_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_check_box=define_c_func(ga,"app_add_check_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_radio_button=define_c_func(ga,"app_add_radio_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_radio_group=define_c_func(ga,"app_add_radio_group",{C_POINTER},C_POINTER),
app_add_field=define_c_func(ga,"app_add_field",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_add_password_field=define_c_func(ga,"app_add_password_field",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_add_text_box=define_c_func(ga,"app_add_text_box",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_add_image_label=define_c_func(ga,"app_add_image_label",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT},C_POINTER),
app_add_label=define_c_func(ga,"app_add_label",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT},C_POINTER),
app_add_tab_button=define_c_func(ga,"app_add_tab_button",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_drop_list=define_c_func(ga,"app_add_drop_list",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_POINTER},C_POINTER),
app_add_drop_field=define_c_func(ga,"app_add_drop_field",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),
app_add_scroll_bar=define_c_func(ga,"app_add_scroll_bar",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT,C_POINTER},C_POINTER),

app_change_scroll_bar=define_c_proc(ga,"app_change_scroll_bar",{C_POINTER,C_INT,C_INT,C_INT}),
app_bring_control_to_front=define_c_proc(ga,"app_bring_control_to_front",{C_POINTER}),
app_redraw_control=define_c_proc(ga,"app_redraw_control",{C_POINTER}),

app_pop_up_list=define_c_func(ga,"app_pop_up_list",{C_POINTER,C_POINTER,C_POINTER,C_INT,C_INT,C_INT},C_INT),

app_move_control=define_c_proc(ga,"app_move_control",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_size_control=define_c_proc(ga,"app_size_control",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_set_focus=define_c_proc(ga,"app_set_focus",{C_POINTER}),
app_has_focus=define_c_func(ga,"app_has_focus",{C_POINTER},C_INT),
app_pass_event=define_c_proc(ga,"app_pass_event",{C_POINTER}),
app_change_list_box=define_c_proc(ga,"app_change_list_box",{C_POINTER,C_POINTER}),
app_reset_list_box=define_c_proc(ga,"app_reset_list_box",{C_POINTER}),
app_set_control_text=define_c_proc(ga,"app_set_control_text",{C_POINTER,C_POINTER}),
app_get_control_text=define_c_func(ga,"app_get_control_text",{C_POINTER},C_POINTER),
app_set_control_background=define_c_proc(ga,"app_set_control_background",{C_POINTER,C_INT}),
app_set_control_foreground=define_c_proc(ga,"app_set_control_foreground",{C_POINTER,C_INT}),

app_cut_text=define_c_proc(ga,"app_cut_text",{C_POINTER}),
app_copy_text=define_c_proc(ga,"app_copy_text",{C_POINTER}),
app_clear_text=define_c_proc(ga,"app_clear_text",{C_POINTER}),
app_paste_text=define_c_proc(ga,"app_paste_text",{C_POINTER}),
app_insert_text=define_c_proc(ga,"app_insert_text",{C_POINTER,C_POINTER}),
app_select_text=define_c_proc(ga,"app_select_text",{C_POINTER,C_INT,C_INT}),
app_text_selection=define_c_proc(ga,"app_text_selection",{C_POINTER,C_POINTER,C_POINTER}),

app_set_field_allowed_width=define_c_proc(ga,"app_set_field_allowed_width",{C_POINTER,C_INT}),
app_set_field_allowed_chars=define_c_proc(ga,"app_set_field_allowed_chars",{C_POINTER,C_POINTER}),
app_set_field_disallowed_chars=define_c_proc(ga,"app_set_field_disallowed_chars",{C_POINTER,C_POINTER}),

-- dialogs
app_error=define_c_proc(ga,"app_error",{C_POINTER,C_POINTER}),
app_ask_ok=define_c_proc(ga,"app_ask_ok",{C_POINTER,C_POINTER,C_POINTER}),
app_ask_ok_cancel=define_c_func(ga,"app_ask_ok_cancel",{C_POINTER,C_POINTER,C_POINTER},C_INT),
app_ask_yes_no=define_c_func(ga,"app_ask_yes_no",{C_POINTER,C_POINTER,C_POINTER},C_INT),
app_ask_yes_no_cancel=define_c_func(ga,"app_ask_yes_no_cancel",{C_POINTER,C_POINTER,C_POINTER},C_INT),
app_ask_string=define_c_func(ga,"app_ask_string",{C_POINTER,C_POINTER,C_POINTER,C_POINTER},C_POINTER),

app_ask_file_open=define_c_func(ga,"app_ask_file_open",{C_POINTER,C_POINTER,C_POINTER,C_POINTER},C_POINTER),
app_ask_file_save=define_c_func(ga,"app_ask_file_save",{C_POINTER,C_POINTER,C_POINTER,C_POINTER},C_POINTER),

-- controls
app_show_control=define_c_proc(ga,"app_show_control",{C_POINTER}),
app_hide_control=define_c_proc(ga,"app_hide_control",{C_POINTER}),
app_is_visible=define_c_func(ga,"app_is_visible",{C_POINTER},C_INT),
app_highlight=define_c_proc(ga,"app_highlight",{C_POINTER}),
app_unhighlight=define_c_proc(ga,"app_unhighlight",{C_POINTER}),
app_is_highlighted=define_c_func(ga,"app_highlight",{C_POINTER},C_INT),
app_flash_control=define_c_proc(ga,"app_flash_control",{C_POINTER}),
app_get_list_box_item=define_c_func(ga,"app_get_list_box_item",{C_POINTER},C_INT),
app_set_list_box_item=define_c_proc(ga,"app_set_list_box_item",{C_POINTER,C_INT}),
app_enable=define_c_proc(ga,"app_enable",{C_POINTER}),
app_disable=define_c_proc(ga,"app_disable",{C_POINTER}),
app_is_enabled=define_c_func(ga,"app_is_enabled",{C_POINTER},C_INT),
app_is_checked=define_c_func(ga,"app_is_checked",{C_POINTER},C_INT),
app_check=define_c_proc(ga,"app_check",{C_POINTER}),
app_uncheck=define_c_proc(ga,"app_uncheck",{C_POINTER}),

-- menus
app_new_menu_bar=define_c_func(ga,"app_new_menu_bar",{C_POINTER},C_POINTER),
app_new_menu=define_c_func(ga,"app_new_menu",{C_POINTER,C_POINTER},C_POINTER),
app_new_sub_menu=define_c_func(ga,"app_new_sub_menu",{C_POINTER,C_POINTER},C_POINTER),
app_new_menu_item=define_c_func(ga,"app_new_menu_item",{C_POINTER,C_POINTER,C_INT,C_POINTER},C_POINTER),
app_del_menu_item=define_c_proc(ga,"app_del_menu_item",{C_POINTER}),
app_check_menu_item=define_c_proc(ga,"app_check_menu_item",{C_POINTER}),
app_uncheck_menu_item=define_c_proc(ga,"app_uncheck_menu_item",{C_POINTER}),
app_menu_item_is_checked=define_c_func(ga,"app_menu_item_is_checked",{C_POINTER},C_INT),
app_enable_menu_item=define_c_proc(ga,"app_enable_menu_item",{C_POINTER}),
app_disable_menu_item=define_c_proc(ga,"app_disable_menu_item",{C_POINTER}),
app_set_menu_item_foreground=define_c_proc(ga,"app_set_menu_item_foreground",{C_POINTER,C_INT}),
app_set_menu_foreground=define_c_proc(ga,"app_set_menu_foreground",{C_POINTER,C_INT}),

-- resources
app_open_resource=define_c_func(ga,"app_open_resource",{C_POINTER,C_POINTER,C_POINTER},C_POINTER),
app_file_has_resources=define_c_func(ga,"app_file_has_resources",{C_POINTER},C_INT),

-- timers
app_delay=define_c_func(ga,"app_delay",{C_POINTER,C_INT},C_INT),
app_current_time=define_c_func(ga,"app_current_time",{C_POINTER},C_LONG),
app_new_timer=define_c_func(ga,"app_new_timer",{C_POINTER,C_POINTER,C_INT},C_POINTER),
app_del_timer=define_c_proc(ga,"app_del_timer",{C_POINTER}),

-- clipboard
app_set_clipboard_text=define_c_func(ga,"app_set_clipboard_text",{C_POINTER,C_POINTER},C_INT),
app_get_clipboard_text=define_c_func(ga,"app_get_clipboard_text",{C_POINTER},C_POINTER),

-- images
app_new_image=define_c_func(ga,"app_new_image",{C_INT,C_INT,C_INT},C_POINTER),
app_del_image=define_c_proc(ga,"app_del_image",{C_POINTER}),
app_copy_image=define_c_func(ga,"app_copy_image",{C_POINTER},C_POINTER),
app_set_image_cmap=define_c_proc(ga,"app_set_image_cmap",{C_POINTER,C_INT,C_POINTER}),

app_read_image=define_c_func(ga,"app_read_image",{C_POINTER,C_INT},C_POINTER),
app_write_image=define_c_func(ga,"app_write_image",{C_POINTER,C_POINTER},C_INT),
app_read_image_file=define_c_func(ga,"app_read_image_file",{C_POINTER,C_INT},C_POINTER),
app_read_image_progressively=define_c_func(ga,"app_read_image_progressively",{C_POINTER},C_POINTER),
app_find_image_format=define_c_func(ga,"app_find_image_format",{C_INT},C_INT),
app_set_control_image=define_c_proc(ga,"app_set_control_image",{C_POINTER,C_POINTER}),
app_get_control_image=define_c_func(ga,"app_get_control_image",{C_POINTER},C_POINTER),
app_image_convert_32_to_8=define_c_func(ga,"app_image_convert_32_to_8",{C_POINTER},C_POINTER),
app_image_convert_8_to_32=define_c_func(ga,"app_image_convert_8_to_32",{C_POINTER},C_POINTER),
app_image_sort_palette=define_c_proc(ga,"app_image_sort_palette",{C_POINTER}),
app_scale_image=define_c_func(ga,"app_scale_image",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT},C_POINTER),
app_draw_image=define_c_proc(ga,"app_draw_image",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_image_monochrome=define_c_proc(ga,"app_draw_image_monochrome",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_image_greyscale=define_c_proc(ga,"app_draw_image_greyscale",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_image_darker=define_c_proc(ga,"app_draw_image_darker",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_image_brighter=define_c_proc(ga,"app_draw_image_brighter",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT,C_INT,C_INT,C_INT}),

-- graphics
app_get_window_graphics=define_c_func(ga,"app_get_window_graphics",{C_POINTER},C_POINTER),
app_get_control_graphics=define_c_func(ga,"app_get_control_graphics",{C_POINTER},C_POINTER),
app_get_bitmap_graphics=define_c_func(ga,"app_get_bitmap_graphics",{C_POINTER},C_POINTER),
app_get_image_graphics=define_c_func(ga,"app_get_image_graphics",{C_POINTER},C_POINTER),
app_del_graphics=define_c_proc(ga,"app_del_graphics",{C_POINTER}),
app_set_rgb=define_c_proc(ga,"app_set_rgb",{C_POINTER,C_INT}),
app_set_rgbindex=define_c_proc(ga,"app_set_rgbindex",{C_POINTER,C_INT}),
app_set_xor_mode=define_c_proc(ga,"app_set_xor_mode",{C_POINTER,C_INT}),
app_set_paint_mode=define_c_proc(ga,"app_set_paint_mode",{C_POINTER}),
app_set_line_width=define_c_proc(ga,"app_set_line_width",{C_POINTER,C_INT}),
app_set_clip_rect=define_c_proc(ga,"app_set_clip_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_set_clip_region=define_c_proc(ga,"app_set_clip_region",{C_POINTER,C_POINTER}),

-- drawing
app_draw_point=define_c_proc(ga,"app_draw_point",{C_POINTER,C_INT,C_INT}),
app_draw_rect=define_c_proc(ga,"app_draw_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_round_rect=define_c_proc(ga,"app_draw_round_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
--         app_fill_rect=define_c_proc(ga,"euapp_fill_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_fill_rect=define_c_proc(ga,"app_window_fill_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_fill_round_rect=define_c_proc(ga,"app_fill_round_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_shadow_rect=define_c_proc(ga,"app_draw_shadow_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT}),
app_draw_ellipse=define_c_proc(ga,"app_draw_ellipse",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_fill_ellipse=define_c_proc(ga,"app_fill_ellipse",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_arc=define_c_proc(ga,"app_draw_arc",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT}),
app_fill_arc=define_c_proc(ga,"app_fill_arc",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT,C_INT}),
app_draw_polyline=define_c_proc(ga,"app_draw_polyline",{C_POINTER,C_POINTER,C_INT}),
app_draw_polygon=define_c_proc(ga,"app_draw_polygon",{C_POINTER,C_POINTER,C_INT}),
app_fill_polygon=define_c_proc(ga,"app_fill_polygon",{C_POINTER,C_POINTER,C_INT}),
app_draw_line=define_c_proc(ga,"app_portable_draw_line",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),

app_draw_text=define_c_proc(ga,"app_draw_text",{C_POINTER,C_INT,C_INT,C_INT,C_INT,C_INT,C_POINTER,C_INT}),

-- fonts
app_new_font=define_c_func(ga,"app_new_font",{C_POINTER,C_POINTER,C_INT,C_INT},C_POINTER),
app_del_font=define_c_proc(ga,"app_del_font",{C_POINTER}),
app_font_height=define_c_func(ga,"app_font_height",{C_POINTER},C_INT),
app_font_width=define_c_func(ga,"app_font_width",{C_POINTER,C_POINTER,C_INT},C_INT),
app_find_default_font=define_c_func(ga,"app_find_default_font",{C_POINTER},C_POINTER),
app_set_font=define_c_proc(ga,"app_set_font",{C_POINTER,C_POINTER}),
app_set_default_font=define_c_proc(ga,"app_set_default_font",{C_POINTER}),

app_set_control_font=define_c_proc(ga,"app_set_control_font",{C_POINTER,C_POINTER}),
app_get_control_font=define_c_func(ga,"app_get_control_font",{C_POINTER},C_POINTER),

-- values
app_set_menu_item_value=define_c_proc(ga,"app_set_menu_item_value",{C_POINTER,C_INT}),
app_get_menu_item_value=define_c_func(ga,"app_get_menu_item_value",{C_POINTER},C_INT),
app_set_control_value=define_c_proc(ga,"app_set_control_value",{C_POINTER,C_INT}),
app_get_control_value=define_c_func(ga,"app_get_control_value",{C_POINTER},C_INT),

app_on_window_close=define_c_proc(ga,"app_on_window_close",{C_POINTER,C_POINTER}),
app_on_window_resize=define_c_proc(ga,"app_on_window_resize",{C_POINTER,C_POINTER}),
app_on_window_redraw=define_c_proc(ga,"app_on_window_redraw",{C_POINTER,C_POINTER}),

app_on_window_mouse_down=define_c_proc(ga,"app_on_window_mouse_down",{C_POINTER,C_POINTER}),
app_on_window_mouse_up=define_c_proc(ga,"app_on_window_mouse_up",{C_POINTER,C_POINTER}),
app_on_window_mouse_drag=define_c_proc(ga,"app_on_window_mouse_drag",{C_POINTER,C_POINTER}),
app_on_window_mouse_move=define_c_proc(ga,"app_on_window_mouse_move",{C_POINTER,C_POINTER}),
app_on_window_key_down=define_c_proc(ga,"app_on_window_key_down",{C_POINTER,C_POINTER}),
app_on_window_key_action=define_c_proc(ga,"app_on_window_key_action",{C_POINTER,C_POINTER}),

app_on_control_mouse_down=define_c_proc(ga,"app_on_control_mouse_down",{C_POINTER,C_POINTER}),
app_on_control_mouse_up=define_c_proc(ga,"app_on_control_mouse_up",{C_POINTER,C_POINTER}),
app_on_control_mouse_drag=define_c_proc(ga,"app_on_control_mouse_drag",{C_POINTER,C_POINTER}),
app_on_control_mouse_move=define_c_proc(ga,"app_on_control_mouse_move",{C_POINTER,C_POINTER}),
app_on_control_key_down=define_c_proc(ga,"app_on_control_key_down",{C_POINTER,C_POINTER}),
app_on_control_key_action=define_c_proc(ga,"app_on_control_key_action",{C_POINTER,C_POINTER}),

app_redraw_rect=define_c_proc(ga,"app_redraw_rect",{C_POINTER,C_INT,C_INT,C_INT,C_INT}),
app_draw_window=define_c_proc(ga,"app_draw_window",{C_POINTER}),
app_redraw_window=define_c_proc(ga,"app_redraw_window",{C_POINTER}),
app_set_window_title=define_c_proc(ga,"app_set_window_title",{C_POINTER,C_POINTER}),
app_get_window_title=define_c_func(ga,"app_get_window_title",{C_POINTER},C_POINTER),

app_get_window_area=define_c_func(ga,"app_get_window_area",{C_POINTER},C_INT),
app_set_window_background=define_c_proc(ga,"app_set_window_background",{C_POINTER,C_INT}),
app_get_window_background=define_c_func(ga,"app_get_window_background",{C_POINTER},C_INT),

-- sound function
app_beep=define_c_proc(ga,"app_beep",{C_POINTER})

global type Window(atom a) return 1 end type
global type Control(atom a) return 1 end type
global type MenuBar(atom a) return 1 end type
global type Menu(atom a) return 1 end type
global type MenuItem(atom a) return 1 end type
global type Font(atom a) return 1 end type
global type Graphics(atom a) return 1 end type
global type Image(atom a) return 1 end type
global type Bitmap(atom a) return 1 end type
global type Timer(atom a) return 1 end type

global constant ALIGN_LEFT      = 1,
ALIGN_RIGHT     = 2,
ALIGN_JUSTIFY   = 3,
ALIGN_CENTER    = 4,
ALIGN_CENTRE    = 4,
VALIGN_TOP      = 8,
VALIGN_BOTTOM   = 16,
VALIGN_JUSTIFY  = 24,
VALIGN_CENTER   = 32,
VALIGN_CENTRE   = 32,
LR_TB           = 64,
RL_TB           = 128,
TB_LR           = 256,
TB_RL           = 512

global constant NO_BUTTON       = 0,
LEFT_BUTTON     = 1,
MIDDLE_BUTTON   = 2,
RIGHT_BUTTON    = 4

global constant CONTROL = #20000000,
SHIFT   = #10000000

global constant SIMPLE_WINDOW   = #00000000

global constant MENUBAR         = #00000010
global constant TITLEBAR        = #00000020
global constant CLOSEBOX        = #00000040
global constant RESIZE          = #00000080
global constant MAXIMIZE        = #00000100
global constant MINIMIZE        = #00000200
global constant HSCROLLBAR      = #00000400
global constant VSCROLLBAR      = #00000800

global constant MODAL           = #00001000
global constant FLOATING        = #00002000
global constant CENTERED        = #00004000
global constant CENTRED         = #00004000

global constant STANDARD_WINDOW=TITLEBAR+CLOSEBOX+RESIZE+MAXIMIZE+MINIMIZE

global constant PLAIN           = 0,
BOLD            = 1,
ITALIC          = 2,
PORTABLE_FONT   = 16,
NATIVE_FONT     = 32

global constant CLEAR   = {#FF,#FF,#FF,#FF},
BLACK   = {#00,#00,#00},
WHITE   = {#FF,#FF,#FF},
BLUE    = {#00,#00,#FF},
YELLOW  = {#FF,#FF,#00},
GREEN   = {#00,#FF,#00},
MAGENTA = {#FF,#00,#FF},
RED     = {#FF,#00,#00},
CYAN    = {#00,#FF,#FF},

GREY        = {#80,#80,#80},
GRAY        = GREY,
LIGHT_GREY  = {#C0,#C0,#C0},
LIGHT_GRAY  = LIGHT_GREY,
PALE_GREY   = {#E0,#E0,#E0},
PALE_GRAY   = PALE_GREY,
DARK_GREY   = {#40,#40,#40},
DARK_GRAY   = DARK_GREY,

DARK_BLUE   = {#00,#00,#80},
DARK_GREEN  = {#00,#80,#00},
DARK_RED    = {#80,#00,#00},
LIGHT_BLUE  = {#80,#C0,#FF},
LIGHT_GREEN = {#80,#FF,#80},
LIGHT_RED   = {#FF,#C0,#FF},
PINK        = {#FF,#AF,#AF},
BROWN       = {#60,#30,#00},
ORANGE      = {#FF,#80,#00},
PURPLE      = {#C0,#00,#FF},
LIME        = {#80,#FF,#00}

atom callbackId
callbackId=0

function callback(atom i)
  callbackId=i
  return 0
end function
constant CallBack=routine_id("callback")

function get_hook(atom hook)
  if hook != -1
    then if hook=0
      then return call_back(CallBack)
    else return call_back(hook)
    end if
  else return 0
  end if
end function

global function string_array(sequence list)
  atom a
  sequence s
  s = {}
  for i = 1 to length(list) do
    s = append(s,allocate_string(list[i]))
  end for
  s = append(s,0) -- null terminator
  a = allocate(length(s) * 4)
  poke4(a,s)
  return a
end function

function argb(sequence clr)
  atom rgb
  if length(clr)=3 then clr &= 0 end if
  rgb=clr[3]*#1000000+
  clr[2]*#10000+
  clr[1]*#100+
  clr[4]
  return rgb
end function

function rgbsep(atom argb)
  object high,low
  high=floor(argb/#10000)
  high={floor(high/#10000),remainder(high,#10000)}
  low=remainder(argb,#10000)
  low={floor(low/#10000),remainder(low,#10000)}
  return high&low
end function

global function new_list_box(atom win,Rect r,sequence list,integer hook)
  sequence str
  atom ctl,cb,ptr,lptr
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  if length(list)=0 then
    lptr=0
  else
    lptr=string_array(list)
  end if
  ctl=c_func(app_new_list_box,{win}&r&{lptr,cb})
  return ctl
end function

global function add_list_box(atom win,Rect r,sequence list,integer hook)
  sequence str
  atom ctl,cb,ptr,lptr
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  if length(list)=0 then
    lptr=0
  else
    lptr=string_array(list)
  end if
  ctl=c_func(app_add_list_box,{win}&r&{lptr,cb})
  return ctl
end function

global function new_drop_list(atom win,Rect r,sequence lines,integer hook)
  atom cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  return c_func(app_new_drop_list,win&r&string_array(lines)&cb)
end function

global function add_drop_list(atom win,Rect r,sequence lines,integer hook)
  atom ctl,cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  return c_func(app_add_drop_list,win&r&string_array(lines)&cb)
end function

global function new_scroll_bar(atom win,sequence r,integer max,integer size_shown,integer hook)
  integer cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  return c_func(app_new_scroll_bar,win&r&max&size_shown&cb)
end function

global function add_scroll_bar(atom win,sequence r,integer max,integer size_shown,integer hook)
  integer cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  return c_func(app_add_scroll_bar,win&r&max&size_shown&cb)
end function

global function change_scroll_bar(atom win,integer max,integer size_shown)
  return c_func(app_change_scroll_bar,win&max&size_shown)
end function

global function new_drop_field(atom win,Rect r,sequence lines)
  atom ctl
  return c_func(app_new_drop_field,win&r&string_array(lines))
end function

global function add_drop_field(atom win,Rect r,sequence lines)
  atom ctl
  return c_func(app_add_drop_field,win&r&string_array(lines))
end function

global function get_list_box_item(atom ctl)
  return c_func(app_get_list_box_item,{ctl})+1
end function

global function get_drop_list_item(atom ctl)
  return c_func(app_get_control_value,{ctl})+1
end function

global procedure set_drop_list_item(atom ctl,integer i)
  c_proc(app_set_control_value,{ctl,i-1})
end procedure

global procedure set_list_box_item(atom ctl,integer ind)
  c_proc(app_set_list_box_item,{ctl,ind-1})
end procedure

global function new_check_box(atom win,Rect r,sequence title,integer hook)
  atom ctl,cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_new_check_box,{win}&r&{allocate_string(title),cb})
  return ctl
end function

global function new_radio_group(atom win)
  return c_func(app_new_radio_group,{win})
end function

global function add_radio_group(atom win)
  return c_func(app_add_radio_group,{win})
end function

global function new_radio_button(atom win,Rect r,sequence title,integer hook)
  atom ctl,cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_new_radio_button,{win}&r&{allocate_string(title),cb})
  return ctl
end function

global function new_image_check_box(atom win,Rect r,atom img,integer hook)
  atom ctl,cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_new_image_check_box,{win}&r&{img,cb})
  return ctl
end function

global function add_check_box(atom win,Rect r,sequence title,integer hook)
  atom ctl,cb
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_add_check_box,{win}&r&{allocate_string(title),cb})
  return ctl
end function

global function add_radio_button(atom win,Rect r,sequence title,integer hook)
  atom ctl,cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_add_radio_button,{win}&r&{allocate_string(title),cb})
  return ctl
end function

global function add_image_check_box(atom win,Rect r,atom img,integer hook)
  atom ctl,cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_add_image_check_box,{win}&r&{img,cb})
  return ctl
end function

global function is_checked(atom ctl)
  return c_func(app_is_checked,{ctl})
end function

global procedure check(atom ctl)
  c_proc(app_check,{ctl})
end procedure

global procedure uncheck(atom ctl)
  c_proc(app_uncheck,{ctl})
end procedure

global procedure enable(atom ctl)
  c_proc(app_enable,{ctl})
end procedure

global procedure disable(atom ctl)
  c_proc(app_disable,{ctl})
end procedure

global function new_button(atom win,Rect r,sequence title,integer hook)
  atom cb,ctl,sptr
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  sptr=allocate_string(title)
  ctl=c_func(app_new_button,{win}&r&{sptr,cb})
  free(sptr)
  return ctl
end function

global function new_image_button(atom win,Rect r,atom img,integer hook)
  atom cb,ctl
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_new_image_button,{win}&r&{img,cb})
  return ctl
end function

global function add_button(atom win,Rect r,sequence title,integer hook)
  atom cb,ctl,sptr
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  sptr=allocate_string(title)
  ctl=c_func(app_add_button,{win}&r&{sptr,cb})
  free(sptr)
  return ctl
end function

global function add_image_button(atom win,Rect r,atom img,integer hook)
  atom cb,ctl
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  ctl=c_func(app_add_image_button,{win}&r&{img,cb})
  return ctl
end function

global function get_control_text(atom ctl)
  atom ptr
  integer ch
  sequence str
  
  str=""
  ptr=c_func(app_get_control_text,{ctl})
  while 1 do
    ch=peek(ptr)
    if ch=0 then exit end if
    str &= ch
    ptr += 1
  end while
  return str
end function

global function new_field(atom win,Rect r,sequence txt)
  return c_func(app_new_field,{win}&r&allocate_string(txt))
end function

global function new_password_field(atom win,Rect r,sequence txt)
  return c_func(app_new_password_field,{win}&r&allocate_string(txt))
end function

global function new_text_box(atom win,Rect r,sequence txt)
  return c_func(app_new_text_box,{win}&r&allocate_string(txt))
end function

global function add_field(atom win,Rect r,sequence txt)
  return c_func(app_add_field,{win}&r&allocate_string(txt))
end function

global function add_password_field(atom win,Rect r,sequence txt)
  return c_func(app_add_password_field,{win}&r&allocate_string(txt))
end function

global function add_text_box(atom win,Rect r,sequence txt)
  return c_func(app_add_text_box,{win}&r&allocate_string(txt))
end function

global procedure set_field_allowed_width(atom fld,integer i)
  c_proc(app_set_field_allowed_width,{fld,i})
end procedure

global procedure set_field_allowed_chars(atom fld,sequence chr)
  c_proc(app_set_field_allowed_chars,{fld,allocate_string(chr)})
end procedure

global procedure set_field_disallowed_chars(atom fld,sequence chr)
  c_proc(app_set_field_disallowed_chars,{fld,allocate_string(chr)})
end procedure

global procedure copy_text(atom ctl)
  c_proc(app_copy_text,{ctl})
end procedure

global procedure cut_text(atom ctl)
  c_proc(app_cut_text,{ctl})
end procedure

global procedure clear_text(atom ctl)
  c_proc(app_clear_text,{ctl})
end procedure

global procedure paste_text(atom ctl)
  c_proc(app_paste_text,{ctl})
end procedure

global procedure insert_text(atom ctl,sequence s)
  c_proc(app_insert_text,{ctl,allocate_string(s)})
end procedure

global procedure select_text(atom ctl,integer s,integer e)
  c_proc(app_select_text,{ctl,s,e})
end procedure

global function text_selection(atom ctl)
  sequence retn
  atom ptr
  
  ptr=allocate(8)
  c_proc(app_text_selection,{ctl,ptr,ptr+4})
  retn={peek4u(ptr),peek4u(ptr+4)}
  free(ptr)
  return retn
end function

global function new_window(Rect r,sequence title,integer flags)
  atom win,tptr
  
  tptr=allocate_string(title)
  win=c_func(app_new_window,{app}&r&{tptr,flags})
  free(tptr)
  return win
end function

global procedure redraw_rect(atom w,Rect r)
  c_proc(app_redraw_rect,w&r)
end procedure

global procedure draw_window(atom w)
  c_proc(app_redraw_rect,{w})
end procedure

global procedure redraw_window(atom w)
  c_proc(app_redraw_window,{w})
end procedure

global procedure set_window_title(atom w,sequence t)
  c_proc(app_set_window_title,{w,allocate_string(t)})
end procedure

global function get_window_title(atom w)
  atom ptr
  integer ch
  sequence t
  
  t=""
  ptr=c_func(app_get_window_title,{w})
  while 1 do
    ch=peek(ptr)
    if ch=0 then exit end if
    t &= ch ptr += 1
  end while
  return t
end function

global procedure on_window_mouse_down(atom w,integer hook)
  c_proc(app_on_window_mouse_down,{w,call_back(hook)})
end procedure

global procedure on_window_mouse_up(atom w,integer hook)
  c_proc(app_on_window_mouse_up,{w,call_back(hook)})
end procedure

global procedure on_window_mouse_drag(atom w,integer hook)
  c_proc(app_on_window_mouse_drag,{w,call_back(hook)})
end procedure

global procedure on_window_mouse_move(atom w,integer hook)
  c_proc(app_on_window_mouse_move,{w,call_back(hook)})
end procedure

global procedure on_window_key_down(atom w,integer hook)
  c_proc(app_on_window_key_down,{w,call_back(hook)})
end procedure

global procedure on_window_key_action(atom w,integer hook)
  c_proc(app_on_window_key_action,{w,call_back(hook)})
end procedure

global procedure on_control_mouse_down(atom w,integer hook)
  c_proc(app_on_control_mouse_down,{w,call_back(hook)})
end procedure

global procedure on_control_mouse_up(atom w,integer hook)
  c_proc(app_on_control_mouse_up,{w,call_back(hook)})
end procedure

global procedure on_control_mouse_drag(atom w,integer hook)
  c_proc(app_on_control_mouse_drag,{w,call_back(hook)})
end procedure

global procedure on_control_mouse_move(atom w,integer hook)
  c_proc(app_on_control_mouse_move,{w,call_back(hook)})
end procedure

global procedure on_control_key_down(atom w,integer hook)
  c_proc(app_on_control_key_down,{w,call_back(hook)})
end procedure

global procedure on_control_key_action(atom w,integer hook)
  c_proc(app_on_control_key_action,{w,call_back(hook)})
end procedure

global procedure on_window_close(atom w,integer hook)
  c_proc(app_on_window_close,{w,call_back(hook)})
end procedure

global procedure on_window_resize(atom w,integer hook)
  c_proc(app_on_window_resize,{w,get_hook(hook)})
end procedure

global procedure on_window_redraw(atom w,integer hook)
  c_proc(app_on_window_redraw,{w,call_back(hook)})
end procedure

global procedure set_window_background(atom win,sequence clr)
  c_proc(app_set_window_background,{win,argb(clr)})
end procedure

global function get_window_background(atom win)
  return rgbsep(c_func(app_get_window_background,{win}))
end function

global function pop_up_list(atom win,atom f,sequence lines,integer buttons,sequence pt)
  return c_func(app_pop_up_list,{win,f,string_array(lines),buttons}&pt)+1
end function

global procedure move_control(atom win,Rect rect)
  c_proc(app_move_control,win&rect)
end procedure

global procedure size_control(atom win,Rect rect)
  c_proc(app_size_control,win&rect)
end procedure

global function get_window_area(atom win)
  --    return {0,0,peek4u(win+20),peek4u(win+24)}
  --    pos t.o.v. 0,0 is in 20,24 hoogte breedte in 28,32
  return {peek4u(win+20),peek4u(win+24),peek4u(win+28),peek4u(win+32)}
end function

global procedure highlight(atom c)
  c_proc(app_highlight,{c})
end procedure

global procedure unhighlight(atom c)
  c_proc(app_unhighlight,{c})
end procedure

global procedure flash(atom c)
  c_proc(app_flash_control,{c})
end procedure

global function is_highlighted(atom c)
  return c_func(app_is_highlighted,{c})
end function

global procedure show_control(atom c)
  c_proc(app_show_control,{c})
end procedure

global procedure hide_control(atom c)
  c_proc(app_hide_control,{c})
end procedure

global function is_visible(atom c)
  return c_func(app_is_visible,{c})
end function

global procedure show_window(atom win)
  c_proc(app_show_window,{win})
end procedure

global procedure hide_window(atom win)
  c_proc(app_hide_window,{win})
end procedure

global procedure del_window(atom w)
  c_proc(app_del_window,{w})
end procedure

global procedure del_all_windows()
  c_proc(app_del_all_windows,{app})
end procedure

global procedure hide_all_windows()
  c_proc(app_hide_all_windows,{app})
end procedure

global procedure main_loop()
  c_proc(app_main_loop,{app})
end procedure

global function wait_event()
  return c_func(app_wait_event,{app})
end function

global function next_event()
  integer res

  res=c_func(app_wait_event,{app}) -- same as wait_event
  if res
    then if callbackId
      then res=callbackId
      callbackId=0
    end if
  end if
  return res
end function

function new_app()
  sequence cmdline
  atom app,argv
  
  cmdline=command_line()
  if find("peu",lower(cmdline[1]))
    then cmdline={cmdline[1]}&cmdline[3..length(cmdline)]
    --    else cmdline={cmdline[1]}&cmdline[2..length(cmdline)]
  end if
  argv=string_array(cmdline)
  app=c_func(app_new_app,{length(cmdline),argv})
  return app
end function

global procedure init() app=new_app()
end procedure

global procedure cleanup()
  c_proc(app_del_app,{app})
end procedure

global function has_focus(atom c)
  return c_func(app_has_focus,{c})
end function

global procedure pass_event(atom c)
  c_proc(app_pass_event,{c})
end procedure

global procedure set_focus(atom ctl)
  c_proc(app_set_focus,{ctl})
end procedure

global procedure change_list_box(atom ctl,sequence list)
  atom lptr
  sequence sarray
  
  sarray={}
  for i = 1 to length(list)  do
    sarray &= allocate_string(list[i])
  end for
  lptr=allocate(length(sarray)*4)
  for i = 1 to length(sarray) do
    poke4(lptr+((i-1)*4),sarray[i])
  end for
  c_proc(app_change_list_box,{ctl,lptr})
  free(lptr)
  for i = 1 to length(sarray) do
    free(sarray[i])
  end for
end procedure

global procedure reset_list_box(atom ctl)
  c_proc(app_reset_list_box,{ctl})
end procedure

global procedure set_control_text(atom ctl,sequence txt)
  atom ptr
  
  ptr=allocate_string(txt)
  c_proc(app_set_control_text,{ctl,ptr})
  free(ptr)
end procedure

global procedure set_control_foreground(atom ctl,sequence rgb)
  c_proc(app_set_control_foreground,{ctl,argb(rgb)})
end procedure

global procedure set_control_background(atom ctl,sequence rgb)
  c_proc(app_set_control_background,{ctl,argb(rgb)})
end procedure

global function new_image_label(atom win, Rect r,atom img,integer align)
  return c_func(app_new_image_label,win&r&img&align)
end function

global function add_image_label(atom win, Rect r,atom img,integer align)
  return c_func(app_add_image_label,win&r&img&align)
end function

global function new_label(atom win, Rect r,sequence txt,integer align)
  return c_func(app_new_label,win&r&allocate_string(txt)&align)
end function

global function new_tab_button(atom win,Rect r,sequence txt,integer hook)
  atom cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  return c_func(app_new_tab_button,win&r&allocate_string(txt)&cb)
end function

global function add_label(atom win, Rect r,sequence txt,integer align)
  return c_func(app_add_label,win&r&allocate_string(txt)&align)
end function

global function add_tab_button(atom win,Rect r,sequence txt,integer hook)
  atom cb
  
  cb=get_hook(hook)
  --    if hook != -1 then cb=call_back(hook) end if
  return c_func(app_add_tab_button,win&r&allocate_string(txt)&cb)
end function

global function new_menu_bar(atom win)
  return c_func(app_new_menu_bar,{win})
end function

global function new_menu(atom mb,sequence mname)
  return c_func(app_new_menu,{mb,allocate_string(mname)})
end function

global function new_sub_menu(atom m,sequence n)
  return c_func(app_new_sub_menu,{m,allocate_string(n)})
end function

global function new_menu_item(atom m,sequence iname,integer hotkey,integer hook)
  atom cb
  
  cb=get_hook(hook)
  return c_func(app_new_menu_item,{m,allocate_string(iname),hotkey,cb})
end function

global procedure set_menu_foreground(atom m,sequence rgb)
  c_proc(app_set_menu_foreground,{m,argb(rgb)})
end procedure

global procedure set_menu_item_foreground(atom m,sequence rgb)
  c_proc(app_set_menu_item_foreground,{m,argb(rgb)})
end procedure

global procedure check_menu_item(atom m)
  c_proc(app_check_menu_item,{m})
end procedure

global procedure uncheck_menu_item(atom m)
  c_proc(app_uncheck_menu_item,{m})
end procedure

global function menu_item_is_checked(atom m)
  return c_func(app_menu_item_is_checked,{m})
end function

global procedure error(sequence msg)
  atom mptr
  
  mptr=allocate_string(msg)
  c_proc(app_error,{app,mptr})
  free(mptr)
end procedure

global procedure ask_ok(sequence ttl,sequence msg)
  atom tptr,mptr
  
  tptr=allocate_string(ttl) mptr=allocate_string(msg)
  c_proc(app_ask_ok,{app,tptr,mptr})
  free(tptr) free(mptr)
end procedure

global function ask_ok_cancel(sequence title,sequence question)
  atom tptr,qptr
  integer resp
  
  tptr=allocate_string(title) qptr=allocate_string(question)
  resp=c_func(app_ask_ok_cancel,{app,tptr,qptr})
  free(tptr) free(qptr)
  return resp
end function

global function ask_yes_no(sequence title,sequence question)
  atom tptr,qptr
  integer resp
  
  tptr=allocate_string(title) qptr=allocate_string(question)
  resp=c_func(app_ask_yes_no,{app,tptr,qptr})
  free(tptr) free(qptr)
  return resp
end function

global function ask_yes_no_cancel(sequence title,sequence question)
  atom tptr,qptr
  integer resp
  
  tptr=allocate_string(title) qptr=allocate_string(question)
  resp=c_func(app_ask_yes_no_cancel,{app,tptr,qptr})
  free(tptr) free(qptr)
  return resp
end function

global function ask_string(sequence title,sequence question,sequence default)
  atom tptr,qptr,dptr,aptr
  integer ch
  sequence answer
  
  answer=""
  tptr=allocate_string(title)
  qptr=allocate_string(question)
  dptr=allocate_string(default)
  aptr=c_func(app_ask_string,{app,tptr,qptr,dptr})
  free(tptr) free(qptr) free(dptr)
  if aptr=0 then return "" end if
  while 1 do
    ch=peek(aptr)
    if ch=0 then exit end if
    answer &= ch
    aptr += 1
  end while
  return answer
end function

global function ask_file_open(sequence title,sequence msg,sequence path)
  atom tptr,mptr,pptr,retn
  integer ch
  sequence retst
  
  tptr=allocate_string(title)
  mptr=allocate_string(msg)
  pptr=allocate_string(path)
  retst=""
  retn=c_func(app_ask_file_open,{app,tptr,mptr,pptr})
  if retn=0 then return 0 end if
  while 1 do
    ch=peek(retn)
    if ch=0 then exit end if
    retst &= ch
    retn += 1
  end while
  free(tptr)
  free(mptr)
  free(pptr)
  return retst
end function

global function ask_file_save(sequence title,sequence msg,sequence path)
  atom tptr,mptr,pptr,retn
  integer ch
  sequence retst
  
  tptr=allocate_string(title)
  mptr=allocate_string(msg)
  pptr=allocate_string(path)
  retst=""
  retn=c_func(app_ask_file_save,{app,tptr,mptr,pptr})
  if retn=0 then return 0 end if
  while 1 do
    ch=peek(retn)
    if ch=0 then exit end if
    retst &= ch
    retn += 1
  end while
  free(tptr)
  free(mptr)
  free(pptr)
  return retst
end function

-- fonts
global function new_font(sequence str,integer style,integer height)
  return c_func(app_new_font,{app,allocate_string(str),style,height})
end function

global procedure del_font(atom fnt)
  c_proc(app_del_font,{fnt})
end procedure

global function font_height(atom fnt)
  return c_func(app_font_height,{fnt})
end function

global function font_width(atom fnt,sequence str)
  return c_func(app_font_width,{fnt,allocate_string(str),length(str)})
end function

global function find_default_font()
  return c_func(app_find_default_font,{app})
end function

global procedure set_font(atom g,atom fnt)
  c_proc(app_set_font,{g,app})
end procedure

global procedure set_default_font(atom g)
  c_proc(app_set_font,{g})
end procedure

global procedure set_control_font(atom c,atom f)
  c_proc(app_set_control_font,{c,f})
end procedure

global function get_control_font(atom c)
  return c_func(app_get_control_font,{c})
end function

-- graphics
global function get_window_graphics(atom w)
  return c_func(app_get_window_graphics,{w})
end function

global function get_control_graphics(atom w)
  return c_func(app_get_control_graphics,{w})
end function

global function get_bitmap_graphics(atom w)
  return c_func(app_get_bitmap_graphics,{w})
end function

global function get_image_graphics(atom w)
  return c_func(app_get_image_graphics,{w})
end function

global procedure del_graphics(atom g)
  c_proc(app_del_graphics,{g})
end procedure

global procedure set_rgb(atom g,sequence rgb)
  c_proc(app_set_rgb,{g,argb(rgb)})
end procedure

global procedure set_rgbindex(atom g,integer i)
  c_proc(app_set_rgbindex,{g,i})
end procedure

global procedure set_xor_mode(atom g,sequence rgb)
  c_proc(app_set_xor_mode,{g,argb(rgb)})
end procedure

global procedure set_paint_mode(atom g)
  c_proc(app_set_paint_mode,{g})
end procedure

global procedure set_line_width(atom g,integer w)
  c_proc(app_set_line_width,{g,w})
end procedure

global procedure set_clip_rect(atom g,Rect r)
  c_proc(app_set_clip_rect,g&r)
end procedure

-- drawing
global procedure draw_line(atom g,Point p1,Point p2)
  c_proc(app_draw_line,g&p1&p2)
end procedure

global procedure draw_point(atom g,Point pt)
  c_proc(app_draw_point,g&pt)
end procedure

global procedure draw_rect(atom g,Rect r)
  c_proc(app_draw_rect,g&r)
end procedure

global procedure fill_rect(atom g,Rect r)
  c_proc(app_fill_rect,g&r)
end procedure

global procedure draw_round_rect(atom g,Rect r)
  c_proc(app_draw_round_rect,g&r)
end procedure

global procedure fill_round_rect(atom g,Rect r)
  c_proc(app_fill_round_rect,g&r)
end procedure

global procedure draw_shadow_rect(atom g,Rect r,sequence c1,sequence c2)
  c_proc(app_draw_shadow_rect,g&r&argb(c1)&argb(c2))
end procedure

global procedure draw_ellipse(atom g,Rect r)
  c_proc(app_draw_ellipse,g&r)
end procedure

global procedure fill_ellipse(atom g,Rect r)
  c_proc(app_fill_ellipse,g&r)
end procedure

global procedure draw_arc(atom g,Rect r,integer sa,integer ea)
  c_proc(app_draw_arc,g&r&sa&ea)
end procedure

global procedure fill_arc(atom g,Rect r,integer sa,integer ea)
  c_proc(app_fill_arc,g&r&sa&ea)
end procedure

global procedure draw_polyline(atom g,sequence points)
  atom ptr,offs
  
  ptr=allocate(length(points)*8)
  offs=ptr
  for i = 1 to length(points) do
    poke4(ptr,points[i])
    offs += 8
  end for
  c_proc(app_draw_polyline,g&ptr&length(points))
  free(ptr)
end procedure

global procedure draw_polygon(atom g,sequence points)
  atom ptr,offs
  
  ptr=allocate(length(points)*8)
  offs=ptr
  for i = 1 to length(points) do
    poke4(ptr,points[i])
    offs += 8
  end for
  c_proc(app_draw_polygon,g&ptr&length(points))
  free(ptr)
end procedure

global procedure fill_polygon(atom g,sequence points)
  atom ptr,offs
  
  ptr=allocate(length(points)*8)
  offs=ptr
  for i = 1 to length(points) do
    poke4(ptr,points[i])
    offs += 8
  end for
  c_proc(app_fill_polygon,g&ptr&length(points))
  free(ptr)
end procedure

global procedure draw_text(atom g,Rect r,integer align,sequence str)
  atom ptr
  
  ptr=allocate_string(str)
  c_proc(app_draw_text,g&r&align&ptr&length(str))
  free(ptr)
end procedure

-- clipboard
global function set_clipboard_text(sequence text)
  return c_func(app_set_clipboard_text,{app,allocate_string(text)})
end function

global function get_clipboard_text(sequence text)
  atom ptr
  integer ch
  sequence str
  
  str=""
  ptr=c_func(app_get_clipboard_text,{app})
  while 1 do
    ch=peek(ptr)
    if ch=0 then exit end if
    str &= ch
    ptr += 1
  end while
  return str
end function

-- images
global function get_image_area(atom im)
  return {0,0,peek4u(im+4),peek4u(im+8)}
end function

global function new_image(integer w,integer h,integer depth)
  return c_func(app_new_image,{w,h,depth})
end function

global procedure del_image(atom img)
  c_proc(app_del_image,{img})
end procedure

global function copy_image(atom img)
  return c_func(app_copy_image,{img})
end function

global procedure set_image_cmap(atom img,sequence colors)
  atom ptr
  
  ptr=allocate(length(colors)*4)
  for i = 0 to length(colors)+1 do
    poke4(ptr+(i*4),colors[i+1])
  end for
  c_proc(app_set_image_cmap,{img,length(colors),ptr})
  free(ptr)
end procedure

global function write_image(atom img,sequence file)
  return c_func(app_write_image,{img,allocate_string(file)})
end function

global function read_image(sequence str,integer depth)
  atom sptr,img
  
  sptr=allocate_string(str)
  img=c_func(app_read_image,{sptr,depth})
  free(sptr)
  return img
end function

global function read_image_file(integer fp,integer depth)
  return c_func(app_read_image_file,{fp,depth})
end function

global procedure set_control_image(atom ctl,atom img)
  c_proc(app_set_control_image,{ctl,img})
end procedure

global function get_control_image(atom ctl)
  return c_func(app_get_control_image,{ctl})
end function

global function image_convert_32_to_8(atom img)
  return c_func(app_image_convert_32_to_8,{img})
end function

global function image_convert_8_to_32(atom img)
  return c_func(app_image_convert_8_to_32,{img})
end function

global procedure sort_palette(atom img)
  c_proc(app_image_sort_palette,{img})
end procedure

global function scale_image(atom img,sequence dr,sequence sr)
  return c_func(app_scale_image,{img}&dr&sr)
end function

global procedure draw_image(atom g,sequence dr,atom img,sequence sr)
  c_proc(app_draw_image,{g}&dr&img&sr)
end procedure

global procedure draw_image_monochrome(atom g,sequence dr,atom img,sequence sr)
  c_proc(app_draw_image_monochrome,{g}&dr&img&sr)
end procedure

global procedure draw_image_greyscale(atom g,sequence dr,atom img,sequence sr)
  c_proc(app_draw_image_greyscale,{g}&dr&img&sr)
end procedure

global procedure draw_image_grayscale(atom g,sequence dr,atom img,sequence sr) draw_image_greyscale(g,dr,img,sr)
end procedure

global procedure draw_image_darker(atom g,sequence dr,atom img,sequence sr)
  c_proc(app_draw_image_darker,{g}&dr&img&sr)
end procedure

global procedure draw_image_brighter(atom g,sequence dr,atom img,sequence sr)
  c_proc(app_draw_image_brighter,{g}&dr&img&sr)
end procedure

-- resources
global function open_resource(sequence file,sequence res)
  atom fp,ptr
  
  ptr=allocate(4)
  fp=c_func(app_open_resource,{allocate_string(file),allocate_string(res),ptr})
  free(ptr)
  return fp
end function

global function file_has_resources(sequence file)
  return c_func(app_file_has_resources,{allocate_string(file)})
end function

-- timers
global procedure delay(atom sec)
  atom a
  a=c_func(app_delay,{app,sec})
end procedure

global function current_time()
  return c_func(app_current_time,{app})
end function

global function new_timer(integer hook,integer msec)
  atom cb
  
  cb=call_back(hook)
  if cb=get_hook(hook) then return 0 end if
  return c_func(app_new_timer,{app,cb,msec})
end function

global procedure del_timer(atom t)
  c_proc(app_del_timer,{t})
end procedure

-- values
global procedure set_menu_item_value(atom mi,integer i)
  c_proc(app_set_menu_item_value,{mi,i})
end procedure

global function get_menu_item_value(atom mi)
  return c_func(app_get_menu_item_value,{mi})
end function

global procedure set_control_value(atom mi,integer i)
  c_proc(app_set_control_value,{mi,i})
end procedure

global function get_control_value(atom mi)
  return c_func(app_get_control_value,{mi})
end function

global procedure beep()
  c_proc(app_beep,{app})
end procedure

global procedure bring_control_to_front(atom ctl)
  c_proc(app_bring_control_to_front,{ctl})
end procedure

global procedure redraw_control(atom ctl)
  c_proc(app_redraw_control,{ctl})
end procedure

global function new_control(atom w,Rect r)
  return c_func(app_new_control,w&r)
end function

