/* bound.h
   Built-in funtion interface for compiled Euphoria programs.
   Pete Eberlein <xseal@harborside.com>
*/
/* next 2 line by menno nov 2005 */
#define wrap_peek4u wrap_peek4
#define wrap_peek4s wrap_peek4
typedef long object;
/* next 3 lines  by menno sept 2000 */
#define make_double(x) ((x) | 0xF9000000)
#define REFERENCE(x)   if (!is_integer(x)) objects[get_index(x)].refcount++;
#define routine_id(x)  (object)&x
#define call_back(x)   x

/* string.c */
extern void   init_command_line(int, char*[]);
extern object build_string(char *);
extern object build_sequence(object, ...);
extern object new_double(double);
extern object repeat(object, object);
extern object subscript(object, object);
extern object slice(object, object, object);
extern object refcount(object);
extern object command_line();

/* builtins.c */
extern object add(object, object);
extern object subtract(object, object);
extern object multiply(object, object);
extern object divide(object, object);
extern void   qprintf(object);
extern void   abort(object);
    
/* system.c */
#define machine_proc machine           
#define machine_func machine

/* for call_proc */
typedef void (*proc0)();
typedef void (*proc1)(object);
typedef void (*proc2)(object,object);
typedef void (*proc3)(object,object,object);
typedef void (*proc4)(object,object,object,object);
typedef void (*proc5)(object,object,object,object,object);
typedef void (*proc6)(object,object,object,object,object,object);
typedef void (*proc7)(object,object,object,object,object,object,object);
typedef void (*proc8)(object,object,object,object,object,object,object,object);
typedef void (*proc9)(object,object,object,object,object,object,object,object,object);
typedef void (*procA)(object,object,object,object,object,object,object,object,object,object);
typedef void (*procB)(object,object,object,object,object,object,object,object,object,object,object);
typedef void (*procC)(object,object,object,object,object,object,object,object,object,object,object,object);
typedef void (*procD)(object,object,object,object,object,object,object,object,object,object,object,object,object);
typedef void (*procE)(object,object,object,object,object,object,object,object,object,object,object,object,object,object);
typedef void (*procF)(object,object,object,object,object,object,object,object,object,object,object,object,object,object,object);

/* for call_func */
typedef object (*func0)();
typedef object (*func1)(object);
typedef object (*func2)(object,object);
typedef object (*func3)(object,object,object);
typedef object (*func4)(object,object,object,object);
typedef object (*func5)(object,object,object,object,object);
typedef object (*func6)(object,object,object,object,object,object);
typedef object (*func7)(object,object,object,object,object,object,object);
typedef object (*func8)(object,object,object,object,object,object,object,object);
typedef object (*func9)(object,object,object,object,object,object,object,object,object);
typedef object (*funcA)(object,object,object,object,object,object,object,object,object,object);
typedef object (*funcB)(object,object,object,object,object,object,object,object,object,object,object);
typedef object (*funcC)(object,object,object,object,object,object,object,object,object,object,object,object);
typedef object (*funcD)(object,object,object,object,object,object,object,object,object,object,object,object,object);
typedef object (*funcE)(object,object,object,object,object,object,object,object,object,object,object,object,object,object);
typedef object (*funcF)(object,object,object,object,object,object,object,object,object,object,object,object,object,object,object);
